@echo on
@SETLOCAL
@REM  First check to make sure you are not running this 
@REM  from the \%SQLANY10%\WIN32 or WIN directory.
if exist dbeng9.exe goto WrongDirectory

if not exist "%SQLANY10%\win32\gencert.exe" goto MISSING_GENCERT

@SET COLLATION=1252LATIN1
@if NOT DEFINED ISQL SET ISQL=dbisql -nogui -onerror exit
@SET PAUSE_BETWEEN_STEPS=

@REM Get the current directory into a variable
for /f %%i in ('cd') do @set curr_dir=%%i

if NOT DEFINED DBMLSYNC_SWITCHES SET DBMLSYNC_SWITCHES=-ot remote.txt -v
SET CONS_DSN=cons
SET REMOTE_DSN=remote
SET PROTOCOL_ML=HTTPS
SET PROTOCOL_CLIENT=HTTPS
SET PORT_SERVER=2439
SET PORT_CLIENT=2439
SET HOST_SERVER=localhost
SET HOST_CLIENT=localhost
SET PASSWORD=password2
SET IIS_GEN_NAME=generated_by_iis
SET IIS_SIGNED_NAME=signed_for_iis.cer
SET ML_USE_THIS_CERT=signed_for_mobilink.cer
SET SAMPLE_CONFIG=1

IF DEFINED USE_IIS_HTTP goto HTTP_REDIRECTOR
IF NOT DEFINED USE_IIS_HTTPS goto CONT1
@echo.
@echo.************************************************************
@echo. When synchronizing through a web server, the dbmlsync 
@echo. process encrypts the data using HTTPS.  The data is 
@echo. encrypted between the client and the web server.
@echo.
@echo. The web server will then forward the de-crypted request
@echo. to the MobiLink server.  The communication between the 
@echo. web server and MobiLink is done using straight
@echo. HTTP (not HTTPS), so MobiLink must be configured to 
@echo. listen for HTTP requests, on a port *other* than 443.
@echo. The client must send it's request on port 443, the default
@echo. HTTPS port.
@echo.************************************************************
@echo.
SET PROTOCOL_ML=HTTP
SET PORT_CLIENT=443
SET ML_USE_THIS_CERT=%IIS_SIGNED_NAME%
SET URL_SUFFIX=;url_suffix=scripts/iaredirect.dll/ml/
SET SAMPLE_CONFIG=3
GOTO CONT1

:HTTP_REDIRECTOR
@echo.
@echo.************************************************************
@echo. dbmlsync can also synchronize through a web server 
@echo. without encrypting the data using standard HTTP.
@echo. Typically you would use HTTPS in this case, but for 
@echo. testing purposes, it is useful to ensure HTTP is working
@echo. before turning on HTTPS.
@echo.************************************************************
@echo.
SET PROTOCOL_ML=HTTP
SET PROTOCOL_CLIENT=HTTP
SET PORT_CLIENT=80
SET URL_SUFFIX=;url_suffix=scripts/iaredirect.dll/ml/
SET SAMPLE_CONFIG=2
GOTO CONT1

:CONT1

@REM The CERTIF_DIR should end in a back-slash
SET CERTIF_DIR=%curr_dir%\cert\

@REM Quadruple up the % signs to escape it to get % supplied.
SET SQL_CUSTOMER="SELECT db_property('name') AS which_database, * FROM Customer"
SET SQL_ENG_MSGS="select message_text from sa_get_server_messages( (property('MaxMessage')-10) ) where message_text like '[0-9]%%%%'"

@if %2. NEQ . GOTO ONE_SYNC

@if %1. EQU all. SET DBMLSYNC_SWITCHES=%DBMLSYNC_SWITCHES% -k
@if %1. EQU . SET PAUSE_BETWEEN_STEPS=1
@if %1. NEQ . GOTO %1

:ALL
@echo.
@echo.************************************************************
@echo.This example will use an SQL Anywhere client directly 
@echo.communicating with a MobiLink server as the default.
@echo.
@echo.This example provides 3 configurations.
@echo.   1. dbmlsync - HTTPS - MobiLink
@echo.   2. dbmlsync - HTTP  - IIS      - HTTP - MobiLink
@echo.   3. dbmlsync - HTTPS - IIS      - HTTP - MobiLink
@echo.
@echo.The default is configuration 1.
@echo.
@echo.If your goal is configuration 3, I recommend using
@echo.configuration 2 first to ensure IIS, MobiLink and the
@echo.MobiLink redirector are properly configured.  
@echo.This can save time debugging your configuration.
@echo.
@echo.To run configuration 1:
@echo.     SET USE_IIS_HTTP=
@echo.     SET USE_IIS_HTTPS=
@echo.     run ml.bat
@echo.
@echo.To run configuration 2:
@echo.     SET USE_IIS_HTTP=1
@echo.     SET USE_IIS_HTTPS=
@echo.     run ml.bat
@echo.
@echo.To run configuration 3:
@echo.     SET USE_IIS_HTTP=
@echo.     SET USE_IIS_HTTPS=1
@echo.     run ml.bat
@echo.
@echo.Configuration is currently set for [%SAMPLE_CONFIG%]
@echo.************************************************************
@echo.
@echo.
@echo.************************************************************
@echo.Stop both the MobiLink server and the database engine
@echo.Delete databases from previous runs
@echo.************************************************************
@echo.
@IF DEFINED PAUSE_BETWEEN_STEPS pause
@echo on
mlstop -w 
dbstop -y cons
@echo off
if exist consdb attrib -r consdb\*.*
if exist remotedb attrib -r remotedb\*.*
if exist backup attrib -r backup\*.*

@echo.
@echo.************************************************************
@echo.Remove the DSN created for the course
@echo.************************************************************
@echo.
@echo on
dbdsn -d %CONS_DSN% -y
dbdsn -d %REMOTE_DSN% -y
@echo off

@echo.
@echo.************************************************************
@echo.Remove all left over directories
@echo.************************************************************
@echo.
if exist consdb (echo y|del /Q consdb) 
if exist remotedb (echo y|del /Q remotedb) 
if exist unload (echo y|del /Q unload)
if exist backup (echo y|del /Q backup)
if exist cert (echo y|del /Q cert)
if exist consdb rmdir consdb
if exist remotedb rmdir remotedb
if exist backup rmdir backup
if exist unload rmdir unload
if exist cert rmdir cert
if exist *.mle del *.mle
if exist remote.txt del remote.txt
if exist ml.txt del ml.txt
if exist 2.sql del 2.sql
if exist stream_log.txt del stream_log.txt

@echo.
@echo.************************************************************
@echo.  All files are cleaned up now
@echo.  The remaining files are needed to setup synchronization.
@echo.  Use CTRL-C to stop ML.BAT
@echo.************************************************************
@echo.
@IF DEFINED PAUSE_BETWEEN_STEPS pause

cd %curr_dir%


@echo.
@echo.************************************************************
@echo.Recreate all the ODBC DSNs 
@echo.************************************************************
@echo.
dbdsn -ws %CONS_DSN% -v -c uid=dba;pwd=sql;eng=cons;dbn=cons;dbf=%curr_dir%\consdb\cons.db;links=shmem -y
dbdsn -ws %REMOTE_DSN% -v -c uid=dba;pwd=sql;eng=cons;dbn=remote;dbf=%curr_dir%\remotedb\remote.db;links=shmem -y

mkdir consdb 
mkdir remotedb 
mkdir unload

@echo.
@echo.************************************************************
@echo.Create databases 
@echo.************************************************************
@echo.
@echo on
dbinit -z %COLLATION% consdb\cons.db
dbinit -z %COLLATION% remotedb\remote.db
@echo off

@echo.
@echo.************************************************************
@echo.Start the database and issue SQL commands
@echo.************************************************************
@echo.
@echo on
dbspawn -f dbeng10 -x tcpip consdb\cons.db
@echo off

@IF %PROTOCOL_CLIENT% EQU HTTP GOTO USE_IIS_ML_REDIRECTOR_HTTP_ONLY

@echo.
@echo.************************************************************
@echo.First generate a ROOT certificate using 
@echo.   "%SQLANY10%\win32\gencert.exe"
@echo.   Choose (R)SA for the type of certificate.
@echo.
@echo.   Use a password of "%PASSWORD%", this password will be
@echo.   required in the next step.
@echo.
@echo.   We are supplying gencert.exe with a input file with 
@echo.   predefined responses, this allows us to create a batch
@echo.   file to do this automatically.
@echo.
@echo.   Here are the values I used when prompted by gencert.exe
@echo.   prompted starting with this line:
@echo.        Choose certificate type ((R)SA or (E)CC): R
@echo.        Enter key length (512-2048): 1024
@echo.        Generating key pair...
@echo.        Country: CA
@echo.        State/Province: Ontario
@echo.        Locality: Waterloo
@echo.        Organization: iAnywhere Solutions
@echo.        Organizational Unit: CSS
@echo.        Common Name: Gencert ROOT certificate
@echo.        Serial Number: 12345
@echo.        Certificate valid for how many years: 10
@echo.        Enter password to protect private key: %PASSWORD%
@echo.        Enter file path to save certificate: ent_root.crt
@echo.        Enter file path to save private key: ent_root.pri
@echo.
@echo.   The output from gencert.exe are the following files:
@echo.           ent_root.crt
@echo.           ent_root.pri
@echo.
@echo.   Cat the output files together to create:
@echo.           ent_serv.cer
@echo.************************************************************
@echo.
@if not exist %CERTIF_DIR% mkdir %CERTIF_DIR%
@chdir %CERTIF_DIR%
@if exist %IIS_SIGNED_NAME% del %IIS_SIGNED_NAME%
@echo on
gencert -r -c < %curr_dir%\create_rsa_root_cert_responses.txt
@echo off
@if NOT %errorlevel% EQU 0 goto ERRORS
copy ent_root.crt + ent_root.pri ent_serv.cer


IF DEFINED USE_IIS_HTTPS goto USE_IIS_ML_REDIRECTOR
IF NOT DEFINED USE_IIS_HTTPS goto USE_ML_ONLY

:USE_IIS_ML_REDIRECTOR
@echo.
@echo.************************************************************
@echo. STOP!
@echo.
@echo. At this point you must use IIS to generate a certificate
@echo. for HTTPS that must be signed by this batch file. 
@echo. Do NOT continue without performing this step.
@echo.
@echo. If you are rerunning this batch file, you must still re-generate
@echo. a new IIS certificate.
@echo.
@echo. Using the instructions found in the 10.0.x Help file:
@echo.    MobiLink - Server Administration
@echo.       Synchronizing Through a Web Server with the Redirector
@echo.          ISAPI Redirector for Microsoft web servers 
@echo.    
@echo.    
@echo.    If you are using HTTPS synchronization, configure your server as
@echo.    follows...
@echo.
@echo.    1. Right-click My Computer and select Manage from the popup menu.
@echo.    2. In the left pane, open the Services and Applications folder. 
@echo.       Select Internet Information Services.
@echo.    3. In the right pane, right-click the default web site and 
@echo.       select Properties from the popup menu.
@echo.    4. Click the Directory Security tab.
@echo.    5. Click Server Certificate.
@echo.       The Web Server Certificate wizard appears.
@echo.    6. Select Create a New Certificate to generate a certificate request. 
@echo.       When prompted for input I used the following values:
@echo.          Create a new certificate
@echo.          Prepare the test now, but send it later.
@echo.
@echo.          Name of certificate:  Generated by IIS
@echo.          Bit length:           1024
@echo.          Organization:         iAnywhere Solutions
@echo.          Organizational Unit:  CSS
@echo.          Common name:          my_machine_name
@echo.          Country:              CA (Canada)
@echo.          State:                Ontario
@echo.          City:                 Waterloo
@echo.          Filename:             %curr_dir%\%IIS_GEN_NAME%.txt
@echo.
@echo.        Click on "Finish" for this wizard.
@echo.
@echo.       The following step will sign the certificate for you.
@echo.
@echo.************************************************************
@echo.
@IF EXIST %curr_dir%\%IIS_GEN_NAME%.txt del %curr_dir%\%IIS_GEN_NAME%.txt
@pause
@echo.
@echo.************************************************************
@echo. Now using "%SQLANY10%\win32\gencert.exe"  
@echo. to sign the certificate generated by IIS.
@echo.************************************************************
@echo.
@IF NOT EXIST %curr_dir%\%IIS_GEN_NAME%.txt GOTO MISSING_IIS_CERT
@echo on
gencert -s -q %curr_dir%\%IIS_GEN_NAME%.txt <%curr_dir%\sign_iis_cert_responses.txt
copy %IIS_GEN_NAME%.crt + ent_root.pri %IIS_SIGNED_NAME%
@echo off
@if NOT %errorlevel% EQU 0 goto ERRORS

@echo.
@echo.************************************************************
@echo. STOP!!
@echo.
@echo. Now you must add the *signed* certificate into IIS.  Cut
@echo. and paste the filename listed below, or browse to this
@echo. file.  NOTE: It is in the HTTPS\cert directory.
@echo.    %CERTIF_DIR%%IIS_SIGNED_NAME%
@echo.
@echo. Using the same steps as the previous step, 
@echo. click the Server Certificate button.
@echo. The IIS Certificate Wizard appears with different prompts this time.
@echo. Choose:
@echo. "Process the pending request and install the certificate".
@echo.
@echo. Click Next and paste in the filename listed above and
@echo. finish the wizard.
@echo.
@echo.
@echo. These instructions are documented here, but you do not need to 
@echo. follow them as the prompts will take you through your next actions.
@echo.    MobiLink Administration Guide 
@echo.       Synchronizing Through a Web Server With the Redirector 
@echo.           ISAPI Redirector for Microsoft web servers
@echo.
@echo. When you have finished adding the signed certificate:
@echo.    1. Click on the Directory Security tab on the IIS website
@echo.    2. Click the View Certificate button
@echo.    3. On the General tab, make sure the following information
@echo.       is displayed:
@echo.         Issued to:  "your machine name"
@echo.         Issued by:  Gencert ROOT certificate
@echo.         Valid from: At least today, plus another 10 years.
@echo.************************************************************
@echo.
@pause

:USE_IIS_ML_REDIRECTOR_HTTP_ONLY
@echo.
@echo.************************************************************
@echo. STOP!!
@echo.
@echo. Now you must correctly configure the MobiLink redirector file  
@echo. using the instructions found at:
@echo.     MobiLink Administration Guide 
@echo.         Synchronizing Through a Web Server With the Redirector 
@echo.             Setting up the Redirector
@echo. 
@echo. On my machine, the scripts directory (located in IIS) is found
@echo. at:  C:\Inetpub\Scripts
@echo.
@echo. I created a file: C:\Inetpub\Scripts\redirector.config
@echo.
@echo. You can read up on what each of these values are for at:
@echo.    MobiLink - Server Administration
@echo.       Synchronizing Through a Web Server with the Redirector
@echo.          Configuring Redirector properties (for Redirectors that don't support server groups) 
@echo.
@echo. The contents of that file are:
@echo.     SLEEP=1800
@echo.     ML=localhost:2439
@echo.     ML_CLIENT_TIMEOUT=1800
@echo.     LOG_LEVEL=2
@echo. 
@echo. There are two files in: C:\Inetpub\Scripts
@echo.     iaredirect.dll
@echo.     redirector.config
@echo.
@echo. NOTE: The scripts directory must be a Virtual Directory under
@echo.       your website with Execute permissions.  You can verify
@echo.       this by following these instructions:
@echo.
@echo.       Control Panel - Administrative Tools - Internet Information Services
@echo.       Expand the "Default Web Site" folder.
@echo.       If you do NOT see an entry called "scripts" then you must
@echo.       create a new Virtual Directory.
@echo.
@echo.       To create the Virtual Directory, right click on the
@echo.       "Default Web Site" folder.
@echo.       Choose New -> Virtual Directory ...
@echo.       The Alias should be "scripts" (no quotes)
@echo.       The Directory should be C:\Inetpub\Scripts 
@echo.       Ensure "Execute" is checked (this is off by default)
@echo.       Finish the wizard.
@echo.
@echo. When you have synchronized and IIS has correctly forwarded a request
@echo. to the MobiLink server, there will be three files in this directory:
@echo.     iaredirect.dll
@echo.     redirector.config
@echo.     redirector.log
@echo.************************************************************
@echo.
@pause

@IF %PROTOCOL_CLIENT% EQU HTTP GOTO STEP1
@IF NOT EXIST %IIS_SIGNED_NAME% GOTO ERRORS


:USE_ML_ONLY
@echo.
@echo.************************************************************
@echo. We must now generate a certificate request, and then use
@echo. our ROOT certificate to sign it.
@echo.
@echo. If we had a FARM (many different) MobiLink servers, we would
@echo. need to do this for EACH MobiLink server.
@echo.
@echo. They can all be signed by the SAME root certificate.
@echo.
@echo. Each remote is provided with the ent_root.crt file, which 
@echo. allows them to encrypt the data.  Since all the MobiLink server
@echo. were signed using the SAME root certificate, they will ALL
@echo. be able to decrypt the client uploads.
@echo.
@echo. We must use the "%SQLANY10%\win32\gencert.exe" 
@echo. to generate a certificate request.  
@echo.   We are supplying gencert.exe with a input file with 
@echo.   predefined responses, this allows us to create a batch
@echo.   file to do this automatically.
@echo.
@echo.   Here are the values I used when prompted by gencert.exe
@echo.   prompted starting with this line:
@echo.        Certificate Generation Tool
@echo.        Choose certificate type ((R)SA or (E)CC): R
@echo.        Enter key length (512-2048): 1024
@echo.        Generating key pair...
@echo.        Country: CA
@echo.        State/Province: Ontario
@echo.        Locality: Waterloo
@echo.        Organization: iAnywhere Solutions
@echo.        Organizational Unit: CSS
@echo.        Common Name: Generated by gencert
@echo.        Serial Number: 56789
@echo.        Certificate valid for how many years: 9
@echo.        Enter file path of signer's certificate: ent_root.crt
@echo.        Enter file path of signer's private key: ent_root.pri
@echo.        Enter password for signer's private key: password2
@echo.        Effective expiry is Tue Jan 20 17:38:27 2014
@echo.        Enter password to protect private key: password2
@echo.        Enter file path to save server identity: signed_for_mobilink.crt
@echo.
@echo.   The output from gencert.exe are the following files:
@echo.           signed_for_mobilink.crt
@echo.
@echo.   Copy the output files together to create:
@echo.           signed_for_mobilink.cer
@echo.************************************************************
@echo.
@if exist %IIS_SIGNED_NAME% del %IIS_SIGNED_NAME%
@echo on
gencert -s < %curr_dir%\create_rsa_request_responses.txt
@echo off
@if NOT %errorlevel% EQU 0 goto ERRORS
copy signed_for_mobilink.crt + ent_root.pri signed_for_mobilink.cer
@if NOT %errorlevel% EQU 0 goto ERRORS

@chdir %curr_dir%

:STEP1
@echo.
@echo.************************************************************
@echo.Step 1 - Create consolidated database 
@echo.
@echo.options.sql      - Some common database options for synchronization
@echo.table_common.sql - Tables used by both consolidated and remotes
@echo.procedures.sql   - Procedures used by consolidated
@echo.sync_scripts.sql - Synchronization scripts used by MobiLink
@echo.initial_data.sql - Initially populates the consolidated
@echo.************************************************************
@echo.
@IF DEFINED PAUSE_BETWEEN_STEPS pause
@echo on
%ISQL% -c "dsn=%CONS_DSN%" read "%SQLANY10%\MobiLink\setup\syncsa.sql"; read options.sql; read table_common.sql; read procedures.sql; read sync_scripts.sql; read initial_data.sql;
@echo off
@if NOT %errorlevel% EQU 0 goto ERRORS

:START_ML
@echo.
@echo.************************************************************
@echo.Start the MobiLink server
@echo.************************************************************
@echo.
@chdir %curr_dir%
SET PROTO_OPTIONS=host=%HOST_SERVER%;port=%PORT_SERVER%
@IF %PROTOCOL_ML% EQU HTTPS SET PROTO_OPTIONS=%PROTO_OPTIONS%;certificate=%CERTIF_DIR%%ML_USE_THIS_CERT%;certificate_password=%PASSWORD%
@echo on
start /min mlsrv10 -zu+ -vcrs -x %PROTOCOL_ML%(%PROTO_OPTIONS%) -c "dsn=%CONS_DSN%" -ot ml.txt
@echo off
@if NOT %errorlevel% EQU 0 goto ERRORS
@if %1. EQU START_ML. goto DONE

:STEP2
@echo.
@echo.************************************************************
@echo.Step 2 - Create remote database 
@echo.
@echo.options.sql      - Some common database options for synchronization
@echo.table_common.sql - Tables used by both consolidated and remotes
@echo.remote_sub.sql   - Creates a publication, sync user, sync subscription
@echo.                   takes parameters to be reused.
@echo.url_suffix       - Required when syncing via IIS, using:
@echo.                   [%URL_SUFFIX%]
@echo.************************************************************
@echo.
@IF DEFINED PAUSE_BETWEEN_STEPS pause
@echo on
%ISQL% -c "dsn=%REMOTE_DSN%;autostop=no" read options.sql; read table_common.sql; 
@echo off
@IF DEFINED PAUSE_BETWEEN_STEPS pause
@IF %PROTOCOL_CLIENT% EQU HTTP GOTO USE_HTTP
@GOTO USE_HTTPS
:USE_HTTP
@echo on
%ISQL% -c "dsn=%REMOTE_DSN%" read remote_sub_http.sql [r1] [%PROTOCOL_CLIENT%] [%HOST_SERVER%] [%PORT_CLIENT%] [%URL_SUFFIX%]
@echo off
@if not %errorlevel% EQU 0 goto DONE
goto STEP3
:USE_HTTPS
@echo on
%ISQL% -c "dsn=%REMOTE_DSN%" read remote_sub_https.sql [r1] [%PROTOCOL_CLIENT%] [%HOST_SERVER%] [%PORT_CLIENT%] [%CERTIF_DIR%ent_root.crt] [%URL_SUFFIX%]
@echo off
@if not %errorlevel% EQU 0 goto DONE
goto STEP3

:STEP3
@echo.
@echo.************************************************************
@echo.Step 3 - Run dbmlsync for the first time to download
@echo.         initial data.
@echo.************************************************************
@echo.
@IF DEFINED PAUSE_BETWEEN_STEPS pause

@echo on
%ISQL% -c "dsn=%REMOTE_DSN%" %SQL_CUSTOMER%
@echo off
@if NOT %errorlevel% EQU 0 goto ERRORS

@echo on
dbmlsync -c "dsn=%REMOTE_DSN%" %DBMLSYNC_SWITCHES%
@echo off
@if NOT %errorlevel% EQU 0 goto ERRORS

@echo on
%ISQL% -c "dsn=%REMOTE_DSN%" %SQL_CUSTOMER%
@echo off
@if NOT %errorlevel% EQU 0 goto ERRORS

goto DONE

:DBMLSYNC
@echo.
@echo.************************************************************
@echo.Run dbmlsync 
@echo.
@echo.************************************************************
@echo.
@IF DEFINED PAUSE_BETWEEN_STEPS pause
@echo on
dbmlsync -c "dsn=%REMOTE_DSN%" %DBMLSYNC_SWITCHES%
@echo off
@if NOT %errorlevel% EQU 0 goto ERRORS

@echo on
%ISQL% -c "dsn=%CONS_DSN%" %SQL_ENG_MSGS%
%ISQL% -c "dsn=%CONS_DSN%" %SQL_CUSTOMER%
@echo off
@if NOT %errorlevel% EQU 0 goto ERRORS

goto DONE

:DONE
@echo.
@echo.************************************************************
@echo. All done tests.
@echo.
@echo. If you wish to start only the MobiLink server you can 
@echo. issue the following from a command prompt:
@echo.     ml.bat start_ml
@echo.
@echo. If you wish to start only the MobiLink client (dbmlsync) you can 
@echo. issue the following from a command prompt:
@echo.     ml.bat dbmlsync
@echo.
@echo. Doing the above will allow you to rerun the test without
@echo. having to regenerate the certificates.
@echo.************************************************************
@echo.

goto END

:ERRORS
@echo.
@echo.************************************************************
@echo. ERROR
@echo. Tests did not complete properly.
@echo. 
@echo. To determine where the error may have occurred you
@echo. must examine two files:
@echo.     %curr_dir%\ml.txt
@echo.     %curr_dir%\rem.txt
@echo. 
@echo. If synchronizing through IIS using the MobiLink Redirector
@echo. then you must also examine:
@echo.     C:\Inetpub\Scripts\redirector.log
@echo. 
@echo. Current directory [%CD%]
@echo.
@echo.************************************************************
@echo.

goto END

:MISSING_GENCERT
@echo off
@echo.
@echo.************************************************************
@echo. SQL Anywhere Studio must have been installed with the
@echo. encryption pack in order to use encrypted security.
@echo.
@echo. Please contact sales to obtain this additional component.
@echo.************************************************************
@echo.
goto END

:MISSING_IIS_CERT
@echo off
@echo.
@echo.************************************************************
@echo. This batch file cannot continue since it cannot find the
@echo. generated certificate from IIS.
@echo.
@echo. Please ensure you followed the directions and saved it to
@echo. the following filename:
@echo.     %curr_dir%\%IIS_GEN_NAME%.txt
@echo.************************************************************
@echo.
goto END

:WrongDirectory
@echo off
cls
@echo.
@echo.************************************************************
@echo.   STOP!!
@echo.You need to create a new/empty directory and copy 
@echo.ML.BAT and the SQL files into that directory.
@echo.************************************************************
@echo.
goto END

:END
@ENDLOCAL
