--
-- This command file reloads a database that was unloaded using "dbunload".
--
-- ( Version :  9.0.2.3420)
--

SET OPTION Statistics          = 3
go
SET OPTION Date_order          = 'YMD'
go
SET OPTION describe_java_format= 'binary'
go
SET OPTION PUBLIC.Preserve_source_format = 'OFF'
go


-------------------------------------------------
--   Create userids and grant user permissions
-------------------------------------------------

GRANT CONNECT TO "DBA" IDENTIFIED BY "SQL"
go
GRANT RESOURCE, DBA, SCHEDULE TO "DBA"
go
GRANT CONNECT TO "dbo"  AT  3
go
GRANT GROUP TO "dbo"
go
GRANT RESOURCE, DBA TO "dbo"
go
commit work
go


-------------------------------------------------
--   Create removed system userids and grant permissions
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Create user-defined types
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Install user-defined classes
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Grant user memberships
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Create external servers
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Create tables
-------------------------------------------------

CREATE TABLE "DBA"."customer"
(
	"cust_1st_pk"   		integer NOT NULL DEFAULT autoincrement ,
	"cust_2nd_pk"   		integer NOT NULL ,
	"first_name"    		varchar(30) NOT NULL ,
	"last_name"     		varchar(30) NOT NULL ,
	"nullable_col"  		varchar(30) NULL ,
	"last_modified" 		timestamp NULL DEFAULT timestamp , 
	 PRIMARY KEY ("cust_1st_pk", "cust_2nd_pk"),
	
)
go
commit work
go


-------------------------------------------------
--   Reload statistics
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Reload data
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Add foreign key definitions
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Create functions
-------------------------------------------------

setuser "DBA" 
go
commit work
go


-------------------------------------------------
--   Create views
-------------------------------------------------

SET TEMPORARY OPTION Force_view_creation='ON'
go

setuser "DBA" 
go
SET TEMPORARY OPTION Force_view_creation='OFF'
go

call dbo.sa_recompile_views(1)
go

commit work
go


-------------------------------------------------
--   Create user messages
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Create procedures
-------------------------------------------------

setuser "DBA" 
go
call dbo.sa_recompile_views(0)
go

commit work
go


-------------------------------------------------
--   Create triggers
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Create SQL Remote definitions
-------------------------------------------------

CREATE REMOTE TYPE "FILE" ADDRESS ''
go
CREATE REMOTE TYPE "MAPI" ADDRESS ''
go
CREATE REMOTE TYPE "VIM" ADDRESS ''
go
CREATE REMOTE TYPE "SMTP" ADDRESS ''
go
CREATE REMOTE TYPE "FTP" ADDRESS ''
go
CREATE PUBLICATION "DBA"."all_tables"
(
	TABLE "DBA"."customer"
)
go
CALL dbo.sa_sync( 1 , 'SET NEXTSYNCID', '' )
go
CREATE SYNCHRONIZATION USER "r1"
        TYPE 'TCPIP' 
go
CALL dbo.sa_sync( 2 , 'SET NEXTSYNCID', '' )
go
CREATE SYNCHRONIZATION SUBSCRIPTION TO "DBA"."all_tables"
        FOR "r1" 
        TYPE 'HTTPS' 
        ADDRESS 'host=localhost;port=443;_logfile=stream_log.txt;_log_all=9;trusted_certificates=C:\files\SQLAny\mobile10\HTTPS\cert\ent_root.crt;url_suffix=scripts/iaredirect.dll/ml/' 
        OPTION memory='2m',ScriptVersion='v1.0',LockTables='off',SendDownloadACK='OFF',Verbose='on' 
go
CALL dbo.sa_sync_sub( 1, 'r1', 'set progress', 427229 )
go
CALL dbo.sa_sync_sub( 1, 'r1', 'set created', 427229 )
go
CALL dbo.sa_sync_sub( 1, 'r1', 'set lastuploadtime', '1900-01-01 00:00:00.000000' )
go
CALL dbo.sa_sync_sub( 1, 'r1', 'set generation_number', '0' )
go
CALL dbo.sa_sync_sub( 1, 'r1', 'set extended_state', '' )
go
CALL dbo.sa_sync( 0 , 'RESET NEXTSYNCID', '' )
go
commit work
go


-------------------------------------------------
--   Remove SQL Remote definitions
-------------------------------------------------

commit work
go


-------------------------------------------------
--   RepServer Commit Offsets
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Load data into MobiLink server system tables
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Create integrated logins
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Create events
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Create services
-------------------------------------------------

commit work
go


-------------------------------------------------
--   Destroy userids
-------------------------------------------------

GRANT CONNECT TO "DBA" IDENTIFIED BY ENCRYPTED '\x78\x76\xA2\x84\x7F\x58\x05\x60\xC1\x90\x35\x60\xC1\x61\xDF\xEB\xD7\x94\x1D\xA7\x38\xA4\x8D\x41\xC4\x40\x50\xCA\x05\x20\x7E\xB3\x96\x91\x18\xD0'
go
commit work
go


-------------------------------------------------
--   Set option values
-------------------------------------------------


SET OPTION Statistics =
go
SET OPTION Date_order =
go
SET OPTION describe_java_format=
go
SET OPTION PUBLIC.Preserve_source_format=
go


--
--SQL Option Statements for user PUBLIC
--

SET OPTION "PUBLIC"."Compression" = '0'
go
SET OPTION "PUBLIC"."Delete_old_logs" = 'On'
go
SET OPTION "PUBLIC"."Login_mode" = 'Mixed'
go
SET OPTION "PUBLIC"."Preserve_source_format" = 'On'
go
commit work
go


-------------------------------------------------
--   Loading QAnywhere message data
-------------------------------------------------

create variable @msg_props long binary
go
create variable @msg_content long binary
go
drop variable @msg_props
go
drop variable @msg_content
go
commit work
go

